unit worldcontent;

interface

uses SysUtils;

type
 TDestState = (ds_open,ds_close,ds_destroy,ds_show,ds_hide);
 TDestStates = set of TDestState;
 TDest = record
  id: integer;
  state: TDestState;
 end;
 TNPC = class
  x,y,yaw,helth,id,gameid: integer;
  rawid: string;
  constructor Create(raw: string; gid,cx,cy,cyaw: integer);
  function FormServerStr: string;
  destructor Remove;
end;

function DestStateToOperateID(DS: TDestState): integer;
procedure DefineDest(id: integer; state: TDestState);
function FindDestByID(id: integer): integer;
function OperateIDToDestState(id: integer): TDestState;


var
 npcs: array [1..8192] of TNPC;
 dests: array [1..8192] of TDest;
 npccount: integer = 0;
 destcount: integer = 0;

implementation

function FindDestByID(id: integer): integer;
 var i: integer;
begin
 Result:= -1;
 for i:= 0 to destcount-1 do
  if dests[i].id = id then
  begin
   result:= i;
   exit;
 end;
end;

procedure DefineDest(id: integer; state: TDestState);
begin
 dests[destcount].id:= id;
 dests[destcount].state:= state;
 inc(destcount);
end;

function DestStateToOperateID(DS: TDestState): integer;
begin
 case DS of
  ds_open: Result:= 0;
  ds_close: Result:= 1;
  ds_destroy: Result:= 2;
  ds_show: Result:= 3;
  ds_hide: result:= 4;
 end;
end;

function OperateIDToDestState(id: integer): TDestState;
begin
 case id of
  0: Result:= ds_open;
  1: Result:= ds_close;
  2: Result:= ds_destroy;
  3: Result:= ds_show;
  4: Result:= ds_hide;
 end;
end;

//==================
// TNPC
//

constructor TNPC.Create(raw: string; gid,cx,cy,cyaw: integer);
begin
 inherited Create;
 inc(npccount);
 id:= npccount;
 npcs[id]:= self;
 x:= cx;
 y:= cy;
 yaw:= yaw;
 rawid:= raw;
 gameid:= gid;
end;

function TNPC.FormServerStr: string;
begin
 Result:= 'NewNpc ('+inttostr(gameid)+','+rawid+','+inttostr(x)+','+inttostr(y)+','+inttostr(yaw)+')';
end;

destructor TNPC.Remove;
begin
 inherited Destroy;
 npcs[id]:= npcs[npccount];
 npcs[id].id:= id;
 dec(npccount);
end;

end.
