unit main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Menus, ScktComp, ExtCtrls, mgscript, mmobd, players, mgscriptnatives,
  worldcontent, DataBaseViewer;

type
  TForm1 = class(TForm)
    LogList: TMemo;
    MainMenu1: TMainMenu;
    MMServer: TMenuItem;
    Label1: TLabel;
    UserList: TListBox;
    GroupBox1: TGroupBox;
    OnlineUser: TLabel;
    TimeUpLabel: TLabel;
    ServerSocket: TServerSocket;
    Button1: TButton;
    TimeUpTimer: TTimer;
    MMServerOn: TMenuItem;
    MMServerOff: TMenuItem;
    ScriptRun: TButton;
    MGScript: TMemo;
    MGS: TGroupBox;
    N1: TMenuItem;
    ScriptParams: TEdit;
    procedure MMServerOnClick(Sender: TObject);
    procedure MMServerOffClick(Sender: TObject);
    procedure TimeUpTimerTimer(Sender: TObject);
    procedure ServerSocketClientConnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerSocketClientDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerSocketClientRead(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ScriptRunClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure N1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

procedure SendMsg(msg: string; notSocket: TCustomWinSocket);

var
  Form1: TForm1;
  timeup,uc: integer;
  database: TCharDataBase;
const
  delitel = #10#11;

implementation

{$R *.dfm}


procedure AddLog(msg: string);
begin
 Form1.LogList.Lines.Add(msg);
end;

function IntToTime(sec: integer):string;
 var min: integer;
begin
 min:= sec div 60;
 Result:= inttostr(min div 60)+':'+inttostr(min mod 60)+':'+inttostr(sec mod 60);
end;

procedure TForm1.MMServerOnClick(Sender: TObject);
begin
 ServerSocket.Active:= true;
 TimeUpTimer.Enabled:= true;
 timeup:= 0;
end;

procedure TForm1.MMServerOffClick(Sender: TObject);
begin
 ServerSocket.Active:= false;
 TimeUpTimer.Enabled:= false;
end;

procedure TForm1.TimeUpTimerTimer(Sender: TObject);
begin
 TimeUpLabel.Caption:= ': '+inttotime(timeup);
 inc(timeup);
end;

procedure SendMsg(msg: string; notSocket: TCustomWinSocket);
 var i: integer;
begin
 with Form1.ServerSocket do
  for i:= 0 to Socket.ActiveConnections-1 do
   if Socket.Connections[i] <> notSocket then
    Socket.Connections[i].SendText(AnsiToUTF8(msg)+delitel);
end;

procedure Send(msg: string; toSocket: TCustomWinSocket);
 var i: integer;
begin
 with Form1.ServerSocket do
  for i:= 0 to Socket.ActiveConnections-1 do
   if Socket.Connections[i] = toSocket then
    Socket.Connections[i].SendText(AnsiToUTF8(msg)+delitel);
end;

procedure TForm1.ServerSocketClientConnect(Sender: TObject; Socket: TCustomWinSocket);
 var i: integer;
begin
 AddLog('connect user with ip ('+Socket.RemoteAddress+')');
end;

procedure TForm1.ServerSocketClientDisconnect(Sender: TObject; Socket: TCustomWinSocket);
begin
 
 AddLog('Client a disconect');
end;

procedure MessageProc(msg: string; Socket: TCustomWinSocket);
 var id,comname,params,charpar: string;
     par: array [1..10] of string;
     j,loccharid: integer;
     mgscript: TStrings;
begin
 AddLog('<- '+msg);
 comname:= GetComName(msg);
 params:= GetComParams(msg);
 //===================================
 if comname = 'execute' then
 begin
  mgscript:= TStringList.Create;
  par[1]:= getComParam(params,1);
  mgscript.Add(par[1]);
  Compile(mgscript,'','');
  mgscript.Destroy;
  exit;
 end;
 if comname = 'run' then
 begin
  par[1]:= GetComParam(params,1);
  par[2]:= GetComParam(params,2);
  par[3]:= GetComParam(params,3);
  if FileExists('scripts\'+par[1]) then
  begin
   mgscript:= TStringList.Create;
   mgscript.LoadFromFile('scripts\'+par[1]);
   Compile(mgscript,par[2],par[3]);
   mgscript.Destroy;
  end;
  exit;
 end;
 //===================================
 if comname = 'update' then
 begin
  DataBase.UpdateCharInfo(params);
 end;
 if comname = 'updatestate' then
 begin
  DataBase.UpdateCharStateInfo(params);
 end;
 //===================================
 if comname = 'connect' then
 begin
  par[1]:= GetComParam(params,1);
  if database.FindChar(par[1]) < 0 then
  begin
   Send('servermsg ("   ")', Socket);
   AddLog('->  ');
   exit;
  end;
  if FileExists('scripts\ServerEvent.mgscript') then
  begin
   mgscript:= TStringList.Create;
   mgscript.LoadFromFile('scripts\ServerEvent.mgscript');
   Compile(mgscript,'PlayerConnect',par[1]);
   mgscript.Destroy;
  end;
  charpar:= database.Chars[database.FindChar(par[1])].GetInfStr;
  par[1]:= GetComParam(charpar,1);
  par[2]:= GetComParam(charpar,4);
  par[3]:= GetComParam(charpar,5);
  par[4]:= GetComParam(charpar,6);
  par[5]:= GetComParam(charpar,3);
  par[6]:= GetComParam(charpar,7);
  par[7]:= GetComParam(charpar,9);
  par[8]:= GetComParam(charpar,8);
  Send('newpl ('+par[1]+','+par[2]+','+par[3]+','+par[4]+','+par[5]+','+par[6]+')',Socket);
  SendMsg('updatestate ('+par[1]+','+par[7]+','+par[8]+')',nil);
  AddLog('->newpl ('+par[1]+','+par[2]+','+par[3]+','+par[4]+','+par[5]+','+par[6]+')');
  AddLog('->updatestate ('+par[1]+','+par[7]+','+par[8]+')');
  for j:= 1 to npccount do
   Send(npcs[j].FormServerStr,Socket);
  loccharid:= strtoint(par[1]);
  for j:= 1 to database.charcount do
   if (not database.GetCharStatus(j)) and (j <> loccharid) then
   begin
    charpar:= database.Chars[database.FindCharById(j)].GetInfStr;
    par[1]:= GetComParam(charpar,1);
    par[2]:= GetComParam(charpar,4);
    par[3]:= GetComParam(charpar,5);
    par[4]:= GetComParam(charpar,6);
    par[5]:= GetComParam(charpar,3);
    par[6]:= GetComParam(charpar,7);
    par[7]:= GetComParam(charpar,9);
    par[8]:= GetComParam(charpar,8);
    Send('newremote ('+par[1]+','+par[2]+','+par[3]+','+par[4]+','+par[5]+','+par[6]+')',Socket);
    SendMsg('updatestate ('+par[1]+','+par[7]+','+par[8]+')',nil);
  end;
  for j:= 0 to destcount-1 do
   Send('destoperate ('+IntToStr(Dests[j].id)+','+IntToStr(DestStateToOperateID(Dests[j].state))+')',Socket);
  exit;
 end;

 SendMsg(msg,Socket);
end;

procedure TForm1.ServerSocketClientRead(Sender: TObject; Socket: TCustomWinSocket);
 var buf_msg,msg: string;
     i: integer;
begin
 buf_msg:= Socket.ReceiveText;
 i:= 0;
 repeat
  i:= Pos(delitel,buf_msg);
  if i <> 0 then
   begin
    msg:= Copy(buf_msg,1,i-1);
    Delete(buf_msg,1,i+Length(delitel)-1);
    MessageProc(UTF8ToAnsi(msg),Socket);
  end;
 until i = 0

end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 database:= TCharDataBase.Load('playerschar.cdb');
 InitNatives(ServerSocket);
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 database.Save;
end;

procedure TForm1.ScriptRunClick(Sender: TObject);
begin
 Compile(MGScript.Lines,'',ScriptParams.Text);
 AddLog('-- Script is Run');
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
 LogList.Clear;
end;

procedure TForm1.N1Click(Sender: TObject);
begin
 DBViewer.Open;
end;

end.
