unit CharDataBase;

interface

uses WorldContent,SysUtils,Classes,Connections,Windows,GroupDataBase;

type
 THAtri = 0..$FFFF;
 THExp = cardinal;
 TClassID = 0..9;
// TRawCode = string[4];
 TCharClass = record
  spell: array [0..5] of TRawCode;
  urc: TRawCode;
  name: string [10];
 end;
 TAccount = record
  login: string [15];
  password: string [16];
  email: string [128];
  chars: array [0..7] of integer;
 end;
 TAccountB = record
   chars: array [0..7] of integer;
   login: string [15];
   password: string [16];
   email: string [128];
   current: byte;
   index: integer;
 end;
 TChar = record
  owner: integer;
  name: string [15];
  exp: THExp;
  charid: integer;
  x,y,z,yaw: integer;
  health: integer;
  mana: integer;
  classid: TClassID;
  spells: array [0..10] of TSpell;
  items:  array [0..5] of TItem;
  locid: integer;
  skillpoints: byte;
  gold: cardinal;
  uptime: cardinal;
  Honor: word;
  killCount: cardinal;
  //Settings
  ban: boolean;
  banTime: cardinal;
  banDisc: string [255];
  mute: boolean;
  muteTime: cardinal;
  UGlvl: word;
 end;
 TCharA = class(Tunit)
  client: TConnection;
  owner: integer;
  charid: integer;
  status: boolean;
  classid: integer;
  db_id: integer;
  gold: cardinal;
  skillpoints: byte;
  uptime: cardinal;
  Honor: word;
  //Settings
  ban: boolean;
  banTime: integer;
  banDisc: string [255];
  mute: boolean;
  muteTime: integer;
  UGLvl: word;
  onChange: procedure (char: TCharA);
  procedure SetExp(exp: cardinal); override;
  constructor Create(rc: string; locId, x,y,z,ry,h,m: integer; utype: TUnitType);
  private
   FKillCount: cardinal;
   function FGetCharUserGroup: TUserGroup;
   function FGetOwner: TAccountB;
   procedure FSetKC(value : cardinal);
  public
   function GetField(field: string): string;
   property KillCount: cardinal read FKillCount write FSetKC;
   property Data;
   property UserGroup: TUserGroup read FGetCharUserGroup;
   property Account: TAccountB read FGetOwner;
 end;
 TCharClassDataBase = class
  constructor Create;
  destructor Destroy(s: boolean);
  private
   _path: string;
  public
   isSaving: boolean;
   classcount: byte;
   classs: array of TCharClass;
   procedure Save(path: string);
   function Load(path: string): boolean;
   procedure QSave;
   function AddClassChar(cname: string; sp1,sp2,sp3,sp4,sp5,uraw: TRawCode): integer;
   function GetClassList: string;
  end;
 TCharDataBase = class
  constructor Create;
  destructor Destroy(s: boolean);
  private
   charIDs: array of boolean;
   charIDmax: integer;
  public
   isSaveing: boolean;
   chars: array of TCharA;
   charcount: integer;
   _path: string;
   pathDataTable: string;
   procedure Save(path: string);
   procedure QSave;
   function Load(path: string): boolean;
   function GetFreeCharID: integer;
   function AddChar(nname: string; clid: TClassID; nowner: integer): integer;
   procedure RemoveChar(id: integer);
   //FindChars Func
   function FindCharByName(login: string): integer;
   function FindCharByCharID(cid: integer): integer;
 end; 
 TAccountDataBase = class
  chardb: TCharDataBase;
  constructor Create;
  destructor Destroy(s: boolean);
  public
   isSaveing: boolean;
   _path: string;
   Accounts: array of TAccountB;
   AccountCount: integer;
   function Load(path: string): boolean;
   procedure Save(path: string);
   procedure QSave;
   function AddAccount(nlogin,npassword,nemail: string): integer;
   function AddChar(player,charid: integer): boolean;
   procedure RemoveAccount(id: integer);
   function GetPlayersList: string;
   function FindAccountByName(login: string): integer;
   function FindCharByName(player: integer; name: string): integer;
   function ChaeckPassword(player: integer; pass: string): boolean;
   function GetAccountCharList(id: integer): string;
   procedure DeleteChar(player,charid: integer);
 end;


var ChDataBase: TCharDataBase;
    ChClassDataBase: TCharClassDataBase;
    AcDataBase: TAccountDataBase;

implementation

uses Main, OtherDataBase;

const
 c_passkey: string = 'UwK60UloN9';

function GetClassAgro(clid: integer): byte;
begin
 case clid of
  0: Result:= 30;
  1: Result:= 12;
  2: Result:= 100;
 end;
end;

procedure TCharClassToRec(dest: TCharA; var target: TChar);
 var i,j: integer;
begin
 ZeroMemory(@target,SizeOf(TChar));
//SAVE
 for i:= 0 to 5 do
 begin
  target.items[i].rawcode:= '';
  target.items[i].counts:= 0;
  target.items[i].used:= false;
 end;
 target.killCount:= dest.killCount;
 target.owner:= dest.owner;
 target.name:= dest.name;
 target.exp:= dest.exp;
 target.x:= dest.posx;
 target.y:= dest.posy;
 target.z:= dest.posz;
 target.yaw:= dest.yaw;
 target.health:= dest.health;
 target.mana:= dest.mana;
 target.charid:= dest.charid;
 target.classid:= dest.classid;
 target.locid:= dest.locid;
 target.uptime:= dest.uptime;
 target.gold:= dest.gold;
 target.skillpoints:= dest.skillpoints;
 target.Honor:= dest.Honor;
 target.ban := dest.ban;
 target.banTime := dest.banTime;
 target.banDisc := dest.banDisc;
 target.mute := dest.mute;
 target.muteTime := dest.muteTime;
 target.UGlvl := dest.UGLvl;
 for i:= 0 to 10 do
  target.spells[i] := dest.spells[i];
 for i:= 0 to 5 do
 begin
  target.items[i].used:= false;
  if dest.items[i] >= 0 then
  begin
   j:= FindItemByHITEM(dest.items[i]);
   target.items[i].used:= j >= 0;
   if target.items[i].used then
   begin
    target.items[i].rawcode:= Items[j].RawCode;
    target.items[i].counts:= Items[j].counts;
    target.items[i].used:= true;
   end;
  end;
 end;
end;

function TCharRecToClass(dest: TChar): TCharA;
 var i: integer;
     itm: TItm;
begin
//LOAD
 Result:= TCharA.Create(ChClassDataBase.classs[dest.classid].urc,dest.locid,dest.x,dest.y,dest.z,dest.yaw,dest.health,dest.mana,utPlayer);
 Result.owner:= dest.owner;
 Result.name:= dest.name;
 Result.charid:= dest.charid;
 Result.name:= dest.name;
 Result.classid:= dest.classid;
 Result.Fexp:= dest.exp;
 Result.skillpoints:= dest.skillpoints;
 Result.gold:= dest.gold;
 Result.uptime:= dest.uptime;
 Result.Honor:= dest.Honor;
 Result.killCount:= dest.killCount;
 Result.ban := dest.ban;
 Result.banTime := dest.banTime;
 Result.banDisc := dest.banDisc;
 Result.mute := dest.mute;
 Result.muteTime := dest.muteTime;
 Result.UGLvl := dest.UGlvl;
 for i:= 0 to 10 do
  Result.spells[i] := dest.spells[i];
 for i:= 0 to 5 do
 begin
  if dest.items[i].used then
  begin
   itm:= TItm.Create0(Result.HUnit,dest.items[i].rawcode);
   itm.counts:= dest.items[i].counts;
   Result.AddItem(itm.HItem);
  end;
 end;
end;

{ TCharDataBase }

procedure TCharDataBase.Save(path: string);
 var f: file of TChar;
     i,j: integer;
     char: TChar;
     s: string;
begin
 if isSaveing then exit;
 isSaveing:= true;
 try
  try
   _path:= path;
   AssignFile(f,path);
   Rewrite(f);
   for i:= 0 to charcount-1 do
   begin
    j:= chars[i].DataTable.IndexOfName('GID');
    if j >= 0 then
    begin
     s := chars[i].DataTable[j];
     chars[i].DataTable.Delete(j);
    end;
    if chars[i].DataTable.Count > 0 then
     chars[i].DataTable.SaveToFile(pathDataTable+'\dt_'+chars[i].name+'.txt');
    if j >= 0 then
     chars[i].DataTable.Add(s);
    TCharClassToRec(chars[i],char);
    Write(f,char);
   end;
   CloseFile(f);
  except
   isSaveing:= false;
  end;
 finally
  isSaveing:= false;
 end;
end;

function TCharDataBase.Load(path: string): boolean;
 var f: file of TChar;
     char: TChar;
     i: integer;
begin
 Result:= false;
 if not FileExists(path) then exit;
 _path:= path;
 AssignFile(f,path);
 Reset(f);
 while not EOF(f) do
 begin
  try
   ZeroMemory(@char,SizeOf(TChar));
   Read(f,char);
   i:= charcount;
   inc(charcount);
   SetLength(chars,charcount);
   chars[i]:= TCharRecToClass(char);
   if chars[i].charid < 0 then
   begin
    chars[i].Destroy;
    chars[i]:= nil;
    dec(charcount);
    continue;
   end;
   if chars[i].owner < 0 then
   begin
    chars[i].Destroy;
    chars[i]:= nil;
    dec(charcount);
    continue;
   end;
   chars[i].db_id:= charcount-1;
   chars[i].agro:= GetClassAgro(chars[i].classid);
   if FileExists(pathDataTable+'\dt_'+chars[i].name+'.txt') then
    chars[i].DataTable.LoadFromFile(pathDataTable+'\dt_'+chars[i].name+'.txt');
   if chars[i].charid+1 > charIDmax then
    charIDmax:= chars[i].charid+1;
   SetLength(CharIDs,charIDmax);
   CharIDs[char.charid]:= true;
  except
  end;
 end;
 CloseFile(f);
 Result:= true;
end;

function TCharDataBase.GetFreeCharID: integer;
 var i: integer;
begin
 for i:= 0 to charIDmax-1 do
  if not charIDs[i] then
  begin
   Result:= i;
   charIDs[i]:= true;
  end;
 Result:= charIDmax;
 inc(charIDmax);
 SetLength(CharIDs,CharIDmax);
 CharIDs[Result]:= true;
end;

function TCharDataBase.AddChar(nname: string; clid: TClassID; nowner: integer): integer;
 var j,i: integer;
begin
 Result:= GetFreeCharID;
 j:= charcount;
 inc(charcount);
 SetLength(Chars,charcount);
 Chars[j]:= TCharA.Create(ChClassDataBase.classs[clid].urc,0,0,0,0,0,750,600,utPlayer);
 with Chars[j] do
 begin
  name:= nname;
  charid:= Result;
  classid:= clid;
  owner:= nowner;
  agro:= GetClassAgro(clid);
  for i:= 0 to 4 do
  begin
   spells[i].rawcode:= ChClassDataBase.classs[clid].spell[i];
   spells[i].lvl:= 0;
  end;
  db_id:= j;
 end;
end;

constructor TCharDataBase.Create;
begin
 inherited Create;
 charcount:= 0;
 charidmax:= 0;
end;

destructor TCharDataBase.Destroy(s: boolean);
 var i: integer;
begin
 inherited Create;
 if s then Save(_path);
 for i:= 0 to charcount-1 do
  Chars[i].Destroy;
end;

procedure TCharDataBase.RemoveChar(id: integer);
 var i: integer;
begin
 if id < 0 then exit;
 dec(charcount);
 if chars[id].owner >= 0 then
 begin
  i:= AcDataBase.FindCharByName(chars[id].owner,chars[id].name);
  AcDataBase.Accounts[chars[id].owner].chars[i] := -1;
 end;
 chars[id].Destroy;
 chars[id]:= chars[charcount];
 chars[id].db_id:= id;
 charIDs[chars[id].charid]:= false;
end;

function TCharDataBase.FindCharByName(login: string): integer;
 var i: integer;
begin
 login:= LowerCase(login);
 for i:= 0 to Charcount-1 do
  if LowerCase(Chars[i].name) = login then
  begin
   Result:= i;
   exit;
 end;
 Result:= -1;
end;

function TCharDataBase.FindCharByCharID(cid: integer): integer;
 var i: integer;
begin
 Result:= -1;
 for i:= 0 to CharCount-1 do
  if Chars[i].charid = cid then
  begin
   Result:= i;
   exit;
  end;
end;

procedure TCharDataBase.QSave;
begin
 if _path <> '' then Save(_path);
end;

{ TCharClassDataBase }

function TCharClassDataBase.AddClassChar(cname: string; sp1, sp2, sp3, sp4, sp5, uraw: WorldContent.TRawCode): integer;
 var i: integer;
begin
 i:= classcount;
 inc(classcount);
 SetLength(classs,classcount);
 with classs[i] do
 begin
  name:= cname;
  spell[0]:= sp1;
  spell[1]:= sp2;
  spell[2]:= sp3;
  spell[3]:= sp4;
  spell[4]:= sp5;
  urc:= uraw;
 end;
end;

constructor TCharClassDataBase.Create;
begin
 inherited Create;
end;

destructor TCharClassDataBase.Destroy(s: boolean);
begin
 if s then QSave;
end;

function TCharClassDataBase.GetClassList: string;
 var i: integer;
     list: TStrings;
begin
 list:= TStringList.Create;
 for i:= 0 to classcount-1 do
  list.Add(classs[i].name);
 Result:= list.Text;
 list.Destroy;
end;

function TCharClassDataBase.Load(path: string): boolean;
 var i: integer;
     db: file of TCharClass;
begin
 Result:= false;
 _path:= path;
 if not FileExists(path) then exit;
 AssignFile(db,path);
 Reset(db);
 while not EoF(db) do
 begin
  i:= classcount;
  inc(classcount);
  SetLength(classs,classcount);
  Read(db,classs[i]);
 end;
 CloseFile(db);
 Result:= true;
 _path:= path;
end;

procedure TCharClassDataBase.QSave;
begin
 if _path <> '' then
  Save(_path);
end;

procedure TCharClassDataBase.Save(path: string);
 var i: integer;
     db: file of TCharClass;
begin
 _path:= path;
 AssignFile(db,path);
 Rewrite(db);
 for i:= 0 to classcount-1 do
  Write(db,classs[i]);
 CloseFile(db);
end;

{ TAccountDataBase }

function TAccountDataBase.AddAccount(nlogin, npassword, nemail: string): integer;
 var i: integer;
begin
 Result:= AccountCount;
 inc(AccountCount);
 SetLength(Accounts,AccountCount);
 with Accounts[Result] do
 begin
  login:= nlogin;
  password:= npassword;
  email:= nemail;
  for i:= 0 to 7 do
   chars[i]:= -1;
 end;
end;

function TAccountDataBase.AddChar(player, charid: integer): boolean;
 var i: integer;
begin
 Result:= true;
 if FindCharByName(player,chardb.chars[charid].name) >= 0 then exit;
 with Accounts[player] do
  for i:= 0 to 7 do
   if chars[i] < 0 then
   begin
    chars[i]:= charid;
    exit;
   end;
 Result:= false;
end;

function TAccountDataBase.ChaeckPassword(player: integer; pass: string): boolean;
 var md5: string;
begin
 //md5:= MD5DigestToStr(MD5String(pass));
 Result:= Accounts[player].password = pass;
end;

constructor TAccountDataBase.Create;
begin
 inherited Create;
end;

procedure TAccountDataBase.DeleteChar(player, charid: integer);
 var i: integer;
begin
 with Accounts[player] do
  for i:= 0 to 7 do
   if chars[i] = charid then
   begin
    chars[i]:= -1;
    exit;
   end;
end;

destructor TAccountDataBase.Destroy(s: boolean);
begin
 if s then Save(_path);
 inherited Destroy;
end;

function TAccountDataBase.FindAccountByName(login: string): integer;
 var i: integer;
begin
 login:= LowerCase(login);
 for i:= 0 to AccountCount-1 do
  if LowerCase(Accounts[i].login) = login then
  begin
   Result:= i;
   exit;
  end;
 Result:= -1;
end;

function TAccountDataBase.FindCharByName(player: integer; name: string): integer;
 var i: integer;
begin
 for i:= 0 to 7 do
  if Accounts[player].chars[i] >= 0 then
   if ChDataBase.chars[Accounts[player].chars[i]].name = name then
   begin
    Result:= i;
    exit;
   end;
 Result:= -1;
end;

function TAccountDataBase.GetAccountCharList(id: integer): string;
 var i,j,k: integer;
begin
 Result:= '';
 j:= 0;
 for i:= 0 to 7 do
  if Accounts[id].chars[i] >= 0 then
   begin
    k := ChDataBase.FindCharByCharID(Accounts[id].chars[i]);
    if k >= 0 then
    begin
     Result:= Result+','+ChDataBase.chars[k].name;
     inc(j);
    end; 
   end;
 Result:= IntToStr(j)+Result;
end;

function TAccountDataBase.GetPlayersList: string;
 var i: integer;
begin
 Result:= '';
 for i:= 0 to AccountCount-2 do
  Result:= Result + Accounts[i].login + #13#10;
 Result:= Result + Accounts[AccountCount-1].login;
end;

function AccountToA(b: TAccountB): TAccount;
 var i: integer;
begin
 Result.login:= b.login;
 Result.password:= b.password;
 Result.email:= b.email;
 for i:= 0 to 7 do
  Result.chars[i]:= b.chars[i];
end;

function AccountToB(b: TAccount): TAccountB;
 var i: integer;
begin
 Result.login:= b.login;
 Result.password:= b.password;
 Result.email:= b.email;
 for i:= 0 to 7 do
  Result.chars[i]:= b.chars[i];
end;

function TAccountDataBase.Load(path: string): boolean;
 var db: file of TAccount;
     i: integer;
     acc: TAccount;
begin
 Result:= false;
 if not FileExists(path) then exit;
 AssignFile(db,path);
 Reset(db);
 while not EoF(db) do
 begin
  i:= AccountCount;
  inc(AccountCount);
  SetLength(Accounts,AccountCount);
  Read(db,acc);
  Accounts[i]:= AccountToB(acc);
  Accounts[i].index:= i;
 end;
 CloseFile(db);
 Result:= true;
end;

procedure TAccountDataBase.QSave;
begin
 if _path <> '' then Save(_path);
end;

procedure TAccountDataBase.RemoveAccount(id: integer);
begin
 dec(AccountCount);
 Accounts[id]:= Accounts[AccountCount];
 Accounts[id].index:= id;
end;

procedure TAccountDataBase.Save(path: string);
 var db: file of TAccount;
     i: integer;
     acc: TAccount;
begin
 if isSaveing then exit;
 isSaveing:= true;
 try
  try
  _path:= path;
  AssignFile(db,path);
  Rewrite(db);
  for i:= 0 to AccountCount-1 do
  begin
   acc:= AccountToA(Accounts[i]);
   Write(db,acc);
  end;
  CloseFile(db);
  except
   isSaveing:= false;
  end;
 finally
  isSaveing:= false;
 end;
end;

{ TCharA }

constructor TCharA.Create(rc: string; locId, x, y, z, ry, h, m: integer; utype: TUnitType);
begin
  inherited Create(rc,locid,x,y,z,ry,h,m,utype);
  @onChange := nil;
end;

function TCharA.FGetCharUserGroup: TUserGroup;
begin
 Result := GroupList[Self.UGLvl];
end;

function TCharA.FGetOwner: TAccountB;
begin
 Result := AcDataBase.Accounts[Owner];
end;

procedure TCharA.FSetKC(value: cardinal);
begin
 if @onChange <> nil then
  onChange(Self);
 FKillCount := value;
end;

function TCharA.GetField(field: string): string;
 function b2s(b: boolean): string;
 begin
  if b then Result := 'true' else Result := 'false';
 end;
 function i2s(i: integer): string;
 begin
  Result := IntToStr(i);
 end;
begin
 field := LowerCase(field);
 if field = 'ban' then Result := B2S(ban) else
 if field = 'bantime' then Result := I2S(banTime) else
 if field = 'classid' then Result := I2S(classid) else
 if field = 'gold' then Result := I2S(gold) else
 if field = 'honor' then Result := I2S(honor) else
 if field = 'mute' then Result := B2S(mute) else
 if field = 'mutetime' then Result := I2S(muteTime) else
 if field = 'uptime' then Result := I2S(uptime) else
 if field = 'level' then Result := I2S(ExpToLevel(FExp)) else
 if field = 'pvpkill' then Result := I2S(FKillCount) else
 if field = 'name' then Result := name;
end;

procedure TCharA.SetExp(exp: cardinal);
 var lLvl,cLvl,aExp,lvl: integer;
     i: integer;
begin
 aExp:= exp-FExp;
 lLvl:= ExpToLevel(FExp);
 FExp:= exp;
 cLvl:= ExpToLevel(FExp);
 if aExp <= 0 then exit;
 if cLvl > lLvl then
 begin
  SkillPoints:= SkillPoints+cLvl-lLvl;
  for i := 0 to QuestDataBase.Count-1 do
    QuestDataBase.CheckGiveEffect(i, Self, false);
  client.Send('setsp('+IntToStr(skillpoints)+')');
  if cLvl = 50 then
   SendAllPlayers('servermsg(" '+Name+'  50 ")',nil);
  client.Send('ttmsg('+IntToStr(HUNIT)+',"|c00008000 |r|n|c00FF8040+'+IntToStr(cLvl-lLvl)+'  |r|n|c000080C0+'+IntToStr(aExp)+' exp")');
 end
 else
  client.Send('ttmsg('+IntToStr(HUNIT)+',"|c000080C0+'+IntToStr(aExp)+' exp")');
end;

end.
