unit ScriptLog;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TScriptLogForm = class(TForm)
    Log: TMemo;
  private
    scriptpath: string;
  public
    lastline: integer;
    procedure OpenScript(path: string);
    procedure CloseScript;
    procedure AddLog(msg: string; line: integer);
  end;

var
  ScriptLogForm: TScriptLogForm;

implementation

{$R *.dfm}

{ TScriptLogForm }

procedure TScriptLogForm.AddLog(msg: string; line: integer);
 var l: integer;
begin
 l:= line;
 if l < 0 then
  l:= lastline;
 Log.Lines.Add(' - '+scriptpath+' ['+IntToStr(l)+']: '+msg);
end;

procedure TScriptLogForm.CloseScript;
begin
 Log.Lines.Add('Close script "'+scriptpath+'"');
 scriptpath:= '';
 lastline:= -1;
end;

procedure TScriptLogForm.OpenScript(path: string);
begin
 Log.Lines.Add('Open script "'+path+'"');
 scriptpath:= ExtractFileName(path);
 lastline:= -1;
end;

end.
