program launcher;
 {$APPTYPE CONSOLE}
 //{$DEFINE DEBUG}
 {* $R *.res}

uses
 SysUtils,Classes,Windows,Graphics,ShellApi,MD5,Registry;

var
 Config: TStrings;
 param: string;
 par: array of string;
 pcount: integer;
 md5str: string;
 war3path: string;
 war3ver: string;
 needRestoreFile: boolean = false;

const
 DI_md5: string        = '4935E4285A3E6EC3755D1CE00A2813B6';
 MMOClient_md5: string = '54635E43F29E9092DBA150D7A15B1F3B';
 RTC_md5: string       = 'A697985F4EE7570D638FD60439DE1DFA';
 needWar3Ver: string   = '1, 24, 4, 6387';

label
 CheckVersion,
 Terminate;

function GetWarcraft3Path: string;
  var reg: TRegistry;
begin
  reg := TRegistry.Create;
  reg.RootKey := HKEY_CURRENT_USER;
  reg.OpenKey('Software\Blizzard Entertainment\Warcraft III', false);
  Result := reg.ReadString('InstallPath');
  reg.Free;
end;

function GetFileVersion(AFileName:string): string;
var
  szName: array[0..255] of Char;
  P: Pointer;
  Value: Pointer;
  Len: UINT;
  GetTranslationString:string;
  FFileName: PChar;
  FValid:boolean;
  FSize: DWORD;
  FHandle: DWORD;
  FBuffer: PChar;
begin
  try
    FFileName := StrPCopy(StrAlloc(Length(AFileName) + 1), AFileName);
    FValid := False;
    FSize := GetFileVersionInfoSize(FFileName, FHandle);
    if FSize > 0 then
      try
        GetMem(FBuffer, FSize);
        FValid := GetFileVersionInfo(FFileName, FHandle, FSize, FBuffer);
      except
        FValid := False;
        raise;
      end;
    Result := '';
    if FValid then
      VerQueryValue(FBuffer, '\VarFileInfo\Translation', p, Len)
    else p := nil;
    if P <> nil then
      GetTranslationString := IntToHex(MakeLong(HiWord(Longint(P^)), LoWord(Longint(P^))), 8);
    if FValid then
      begin
        StrPCopy(szName, '\StringFileInfo\' + GetTranslationString + '\FileVersion');
        if VerQueryValue(FBuffer, szName, Value, Len) then
          Result := StrPas(PChar(Value));
      end;
  finally
    try
      if FBuffer <> nil then FreeMem(FBuffer, FSize);
    except
    end;
    try
      StrDispose(FFileName);
    except
    end;
  end;
end;

function GetParamPos(str: string): integer;
 var i: integer;
begin
 Result:= -1;
 for i:= 0 to pcount-1 do
  if par[i] = str then
  begin
   Result:= i;
   exit;
 end;
end;

procedure RepaintSplashScreen;
 var wnd: hwnd;
     dc: hdc;
     bit: TBitmap;
     Canvas: TCanvas;
begin
 wnd:= 0;
 repeat
  wnd:= FindWindow(nil,'Splash Screen');
 until wnd > 0;
 writeln('wnd found: ',wnd);
 bit:= TBitmap.Create;
  try
    bit.LoadFromFile('logo.bmp');
    repeat
      wnd:= FindWindow(nil,'Splash Screen');
      dc:= GetDC(wnd);
      Canvas:= TCanvas.Create;
      try
        Canvas.Handle:= dc;
        Canvas.Draw(0,0,bit);
        ReleaseDC(wnd,dc);
      except
        writeln ('error in spalsh screen');
        Canvas.Free;
        break;
      end;
      Canvas.Free;
    until wnd = 0;
  except
    writeln ('error in canvas drawing');
  end;
  bit.Free;
end;


procedure InitParamList;
 var i: integer;
begin
 pcount:= ParamCount;
 SetLength(par,pcount);
 for i:= 0 to pcount-1 do
  par[i]:= ParamStr(i+1);
end;

procedure War3CheckStatus;
  var wnd: HWND;
      Res: DWORD;
      b: boolean;
begin
  wnd := FindWindow(nil, 'Warcraft III');
  if wnd > 0 then
  begin
    writeln('Warcraft III window found: ',wnd);
    SetWindowText(wnd, 'Forgotten Land WC3 client');
    repeat
      b := SendMessageTimeout(wnd, $0, 0, 0, SMTO_NORMAL or SMTO_ABORTIFHUNG, 1000, Res) <> 0;
    until not b;
  end
  else
    writeln('Warcraft III window not found');
  writeln('Warcraft III is stoped');
end;

begin
 {$IFDEF DEBUG}
 {$ELSE}
 if Pos('-runonce',GetCommandLine) <= 0 then goto terminate;
 {$ENDIF}
 {$IFDEF DEBUG}
  writeln('Run in DEBUG MODE');
 {$ENDIF}
 //CHECK FILE SETS
 {$IFDEF FILES}
 writeln('Check files');
 if not FileExists('DataInfo.dti') then
 begin
  writeln('File DataInfo.dti not found');
  goto terminate;
 end;
 md5str:= MD5DigestToStr(MD5File('DataInfo.dti'));
 if DI_MD5 <> md5str then
 begin
  writeln('File DataInfo.dti uncorrect. Reinstall programm please');
  goto terminate;
 end;
 if not FileExists('Plugins\MMOClient.dll') then
 begin
  writeln('File MMOClient.dll not found');
  goto terminate;
 end;
 md5str:= MD5DigestToStr(MD5File('Plugins\MMOClient.dll'));
 if MMOClient_MD5 <> md5str then
 begin
  writeln('File MMOClient.dll uncorrect. Reinstall programm please');
  goto terminate;
 end;
 if not FileExists('rtc.dll') then
 begin
  writeln('File rtc.dll not found');
  goto terminate;
 end;
 md5str:= MD5DigestToStr(MD5File('rtc.dll'));
 if Rtc_MD5 <> md5str then
 begin
  writeln('File rtc.dll uncorrect. Reinstall programm please');
  goto terminate;
 end;
 {$ENDIF}
 war3path := GetWarcraft3Path;
 writeln('Warcraft 3 path is "',war3path,'"');
 war3ver := GetFileVersion(war3path+'\war3.exe');
 writeln('Warcraft 3 version is ',war3ver);
 if war3ver <> needWar3ver then
 begin
  writeln('uncorrect version. need 1.24.4.6387');
  writeln('Try change war3 version');
  //Save old files
  RenameFile(war3path+'\war3.exe',war3path+'\war3.exe.bac');
  RenameFile(war3path+'\game.dll',war3path+'\game.dll.bac');
  needRestoreFile := true;
  //Copy new files
  CopyFile('war3.exe',PAnsiChar(war3path+'\war3.exe'),FALSE);
  CopyFile('game.dll',PAnsiChar(war3path+'\game.dll'),FALSE);
  war3ver := GetFileVersion(war3path+'\war3.exe');
  writeln('Now warcraft 3 version is '+war3ver);
  
  if war3ver <> needWar3ver then
  begin
    writeln('Can not change war3ver');
    goto Terminate;
  end;
 end;
 //PARAMS ANALISE
 writeln('Get run param list');
 InitParamList;
 writeln('Complete');
 writeln('Start Analise');
 param:= '-loadfile Maps\FL\main.w3x';
 if GetParamPos('-w') >= 0 then
 begin
  writeln('window mode found');
  param:= param + ' -windows';
 end;
 if GetParamPos('-ogl') >= 0 then
 begin
  writeln('opengl mode found');
  param:= param + ' -opengl';
 end;
 writeln('Complete. Summ: ',param);
 writeln('Create Setting');
 //CREATE SETTINGS
 Config:= TStringList.Create;
 Config.Add('[config]');
 Config.Add('DebugMode=0');
 Config.Add('NoCheat=1');
 Config.Add('NoPause=1');
 Config.Add('NoInstanceLimit=1');
 Config.SaveToFile('config.ini');
 Config.Destroy;
 writeln('Complete');
 RenameFile('DataInfo.dti','l.exe');
 writeln('Run rtc.exe with params '+param);
 {$IFDEF NORUN}
  writeln('NORUN is found');
 {$ELSE}
  writeln( ShellExecute(0,nil,'l.exe',PChar(param),nil,0) );
  RepaintSplashScreen;
 {$ENDIF}
 RenameFile('l.exe','DataInfo.dti');
 writeln('complete');
 Sleep(3*1000);
 DeleteFile('config.ini');
 writeln('Succeful');
 War3CheckStatus;
 if needRestoreFile then
 begin
    writeln('Restore old files');
    sleep(3000);
    DeleteFile(PAnsiChar(war3path+'\war3.exe'));
    DeleteFile(PAnsiChar(war3path+'\game.dll'));
    RenameFile(war3path+'\war3.exe.bac',war3path+'\war3.exe');
    RenameFile(war3path+'\game.dll.bac',war3path+'\game.dll');
    war3ver := GetFileVersion(war3path+'\war3.exe');
    writeln('Now warcraft 3 version is ',war3ver);
 end;
 Terminate:
 writeln('Terminated');
 {$IFDEF DEBUG}
  while true do ;
 {$ENDIF}
end.
