unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, FileCtrl, SFMpqApi, MD5;

type
  TMainForm = class(TForm)
    OldFile: TEdit;
    NewFile: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    BeginBtn: TButton;
    BrowseBtn1: TButton;
    BrowseBtn2: TButton;
    ProgressBar: TProgressBar;
    OpenDialog: TOpenDialog;
    procedure BrowseBtn1Click(Sender: TObject);
    procedure BrowseBtn2Click(Sender: TObject);
    procedure BeginBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

procedure TMainForm.BrowseBtn1Click(Sender: TObject);
begin
 if OpenDialog.Execute then
  OldFile.Text := OpenDialog.FileName;
end;

procedure TMainForm.BrowseBtn2Click(Sender: TObject);
begin
 if OpenDialog.Execute then
  NewFile.Text := OpenDialog.FileName;
end;

function ReadFileList(mpq: MPQHandle): TStrings;
 var hFile: THandle;
     size: cardinal;
     buff: Pointer;
begin
 if not SFileOpenFileEx(mpq, '(listfile)', 0, hFile) then Exit;
 size := SFileGetFileInfo(hFile, SFILE_INFO_SIZE);
 GetMem(buff, size);
 if SFileReadFile(hFile, buff, size, nil, nil) then
 begin
  Result := TStringList.Create;
  Result.Text := String(buff); 
 end;
 FreeMem(buff,size);
 SFileCloseFile(hFile);
end;

procedure TMainForm.BeginBtnClick(Sender: TObject);
 var path: string;
     old_hMPQ,new_hMPQ: MPQhandle;
     fileList: TStrings;
     i: integer;
     hFile: THandle;
     size: cardinal;
     buff: Pointer;
     fMD5: array [0..1] of string;
     updateList: TStrings;
     f: file;
begin
 if not SelectDirectory('Select finish dir','',path) then Exit;
 path := path + '\';
 old_hMPQ := MpqOpenArchiveForUpdate(PChar(oldFile.Text),MOAU_OPEN_EXISTING,65535);
 if old_hMPQ > $85200000 then
 begin
    ShowMessage('Can not open '+oldFile.Text);
    Exit;
 end;
 new_hMPQ := MpqOpenArchiveForUpdate(PChar(newFile.Text),MOAU_OPEN_EXISTING,65535);
 if new_hMPQ > $85200000 then
 begin
    ShowMessage('Can not open '+newFile.Text);
    Exit;
 end;
 fileList := ReadFileList(new_hMPQ);
 ProgressBar.Position := 0;
 progressBar.Max := fileList.Count;
 updateList := TStringList.Create;
 for i:= 0 to fileList.Count-1 do
 begin
    //Open First File
    if not SFileOpenFileEx(old_hMPQ,PChar(fileList[i]),0,hFile) then
    begin
      //File not found in old map
      updateList.Add(fileList[i]);
      SFileOpenFileEx(new_hMPQ,PChar(fileList[i]),0,hFile);
      size := SFileGetFileInfo(hFile, SFILE_INFO_SIZE);
      GetMem(buff,size);
      SFileReadFile(hFile,buff,size,nil,nil);
      AssignFile(f,path+ExtractFileName(fileList[i]));
      Rewrite(f,1);
      BlockWrite(f,buff^,size);
      CloseFile(f);
      FreeMem(buff);
      SFileCloseFile(hFile);
    end else begin
      //File found in old map
      //Generate md5 for old file
      size := SFileGetFileInfo(hFile, SFILE_INFO_SIZE);
      GetMem(buff,size);
      SFileReadFile(hFile,buff,size,nil,nil);
      fMD5[0] := MD5DigestToStr(MD5Buffer(buff^,size));
      FreeMem(buff);
      SFileCloseFile(hFile);
      //Generate md5 for new file
      SFileOpenFileEx(new_hMPQ,PChar(fileList[i]),0,hFile);
      size := SFileGetFileInfo(hFile, SFILE_INFO_SIZE);
      GetMem(buff,size);
      SFileReadFile(hFile,buff,size,nil,nil);
      fMD5[1] := MD5DigestToStr(MD5Buffer(buff^,size));
      //Check md5 old and new file
      if fMD5[0] <> fMD5[1] then
      begin
        //New file updated
        updateList.Add(fileList[i]);
        AssignFile(f,path+ExtractFileName(fileList[i]));
        Rewrite(f,1);
        BlockWrite(f,buff^,size);
        CloseFile(f);
      end;
      SFileCloseFile(hFile);
      FreeMem(buff);
    end;
    ProgressBar.Position := i;
 end;
 SFileCloseArchive(old_hMPQ);
 SFileCloseArchive(new_hMPQ);
 updateList.SaveToFile(path+'updatelist.txt');
 fileList.Free;
 updateList.Free;
 ShowMessage('Complete');
end;

end.
