program sfmpqexe;

uses
  SFmpqapi in 'SFmpqapi.pas';

var
  hMPQ: MPQHANDLE;
  hFile: THandle;
  buff: Pointer;
  size: LongInt;
  cmd, arg1, arg2, arg3: PAnsiChar;
  F: File;

{$APPTYPE CONSOLE}

function StrScan(const Str: PChar; Chr: Char): PChar;
begin
  Result := Str;
  while Result^ <> Chr do
  begin
    if Result^ = #0 then
    begin
      Result := nil;
      Exit;
    end;
    Inc(Result);
  end;
end;

function LastDelimiter(const Delimiters, S: string): Integer;
var
  P: PChar;
begin
  Result := Length(S);
  P := PChar(Delimiters);
  while Result > 0 do
  begin
    if (S[Result] <> #0) and (StrScan(P, S[Result]) <> nil) then
      Exit;
    Dec(Result);
  end;
end;

function ExtractFileName(const FileName: string): string;
var
  I: Integer;
begin
  I := LastDelimiter('\:', FileName);
  Result := Copy(FileName, I + 1, MaxInt);
end;




function GetNearPow(x: Integer): Integer;
var
  p: Integer;
begin
  p := $10;
  while x > p do p := p shl 1;
  Result := p;
end;





begin
{
  WriteLn;
  WriteLn('sfmpqexe by swdn (c) 2009');
  WriteLn;
  WriteLn('Syntax: sfmpqexe.exe [command] [mpq] [file] [path]');
}
  cmd  := PAnsiChar(ParamStr(1));
  arg1 := PAnsiChar(ParamStr(2));
  arg2 := PAnsiChar(ParamStr(3));
  arg3 := PAnsiChar(ParamStr(4));

  if cmd = '' then Exit;

  if cmd = '-e' then
  begin
    if arg1 = '' then Exit;
    hMPQ := MpqOpenArchiveForUpdate(arg1, MOAU_OPEN_EXISTING, 65535);
    if hMPQ > $85200000 then
    begin
      //WriteLn('Cannot open ', arg1);
      Exit;
    end;

    if not SFileOpenFileEx(hMPQ, arg2, 0, hFile) then
    begin
      //WriteLn('Cannot open ', arg2, ' in ', arg1);
      Exit;
    end;

    size := SFileGetFileInfo(hFile, SFILE_INFO_SIZE);
    GetMem(buff, size);

    if SFileReadFile(hFile, buff, size, nil, nil) then
    begin
      AssignFile(F, String(arg3));
      Rewrite(F, 1);
      BlockWrite(F, buff^, size);
      CloseFile(F);
    end;

    FreeMem(buff);
    SFileCloseFile(hFile);
    SFileCloseArchive(hMPQ);
  end else

  if cmd = '-i' then
  begin
    if arg1 = '' then Exit;
    hMPQ := MpqOpenArchiveForUpdate(arg1, MOAU_OPEN_EXISTING, 65535);
    if hMPQ > $85200000 then
    begin
      //WriteLn('Cannot open ', arg1);
      Exit;
    end;

    //if (LowerCase(ExtractFileExt(Lst.Strings[i])) = '.w3x') or (LowerCase(ExtractFileExt(Lst.Strings[i])) = '.w3m') then
    MpqAddFileToArchiveEx(hMPQ, arg2, arg3, MAFA_REPLACE_EXISTING, 0, 0);
    {
    else
      MpqAddFileToArchiveEx(hMPQ, PAnsiChar(s + ExtractFileName(Lst.Strings[i])),
                            PAnsiChar(Lst.Strings[i]), MAFA_EXISTS or MAFA_COMPRESS,
                            MAFA_COMPRESS_DEFLATE, Z_BEST_COMPRESSION);
    }

    MpqDeleteFile(hMPQ, '(attributes)');
    SFileCloseArchive(hMPQ);
  end;

end.
