unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, XPMan, StdCtrls, FileCtrl, ActionDlg, SFMpqApi;

type
  TMainForm = class(TForm)
    ToDoList: TListBox;
    ChangeLog: TMemo;
    PatchVersion: TEdit;
    BuildPatch: TButton;
    AddAction: TButton;
    DeleteAction: TButton;
    Label1: TLabel;
    Label2: TLabel;
    XPManifest1: TXPManifest;
    Label3: TLabel;
    procedure BuildPatchClick(Sender: TObject);
    procedure AddActionClick(Sender: TObject);
    procedure ToDoListClick(Sender: TObject);
    procedure DeleteActionClick(Sender: TObject);
  private
    { Private declarations }
  public
    function CompileChangeLog: TStrings;
  end;

type
 TAction = class
  par: array [0..1] of string;
  actionId: integer;
 end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

function VersionToName(version: string): string;
begin
 Result := StringReplace(version,'.','_',[rfReplaceAll]);
end;

function TMainForm.CompileChangeLog: TStrings;
 var i: integer;
begin
 Result := TStringList.Create;
 Result.Add('<html><head><link type="text/css" rel="StyleSheet" href="/ForgottenLand/flstyle.css"></head><body>');
 Result.Add('<h1> '+PatchVersion.Text+'</h1>');
 Result.AddStrings(ChangeLog.Lines);
 Result.Add('<div align="right">Forgotten Land</div>');
end;

procedure TMainForm.BuildPatchClick(Sender: TObject);
 var path,vn: string;
     btn: integer;
     list: TStrings;
     fileList,updateList: TStrings;
begin
 path := ExtractFilePath(Application.ExeName);
 if not SelectDirectory('   ','',path) then
 begin
  btn:= MessageDlg('  ',mtWarning,[mbRetry,mbOK],0);
  case btn of
   mrRetry: begin
              Self.BuildPatchClick(Sender);
              Exit;
            end;
  end;
  Exit;
 end;
 vn:= VersionToName(PatchVersion.Text);
 ShowMessage(path);
 list := CompileChangeLog;
 list.SaveToFile(path+'update_'+vn+'.html');
 list.Clear;
 //   
 ShowMessage(' '+PatchVersion.Text+'  ');
end;

procedure TMainForm.AddActionClick(Sender: TObject);
 var act: TAction;
  function ActID2Str(id: integer): string;
  begin
   Result := 'Unknow';
   case id of
    0: Result := 'Add File';
    1: Result := 'Update Archive';
   end;
  end;
begin
 if not ActionDlg.Execute then Exit;
 act := TAction.Create;
 act.par[0] := ActionDlg.ActionDialog.Param1.Text;
 act.par[1] := ActionDlg.ActionDialog.Param2.Text;
 act.actionId := ActionDlg.ActionDialog.ActionList.ItemIndex;
 ToDoList.AddItem('action: '+ActId2Str(act.actionId)+'&p1: '+act.par[0]+'&p2: '+act.par[1],act);
end;

procedure TMainForm.ToDoListClick(Sender: TObject);
 var i: integer;
begin
 i := ToDoList.ItemIndex;
 DeleteAction.Enabled := i >= 0;
end;

procedure TMainForm.DeleteActionClick(Sender: TObject);
 var i: integer;
begin
 i := ToDoList.ItemIndex;
 DeleteAction.Enabled := i >= 0;
 if i < 0 then Exit;
 ToDoList.Items.Delete(i);
end;

end.
