unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ShellApi, TlHelp32, CoolTrayIcon;

type
  TEventType = (etNotFound, etNotWork);
  TMainForm = class(TForm)
    LogList: TMemo;
    Timer1: TTimer;
    ServerPath: TEdit;
    Label1: TLabel;
    CoolTrayIcon1: TCoolTrayIcon;
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CoolTrayIcon1DblClick(Sender: TObject);
  private
    { Private declarations }
  public
    PID: cardinal;
    procedure OnEvent (event: TEventType; wnd: HWND);
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

function TimeToStr: string;
  var sys: SystemTime;
begin
  GetSystemTime(sys);
  Result := IntToStr(sys.wDay)+'.'+IntToStr(sys.wMonth)+'.'+IntToStr(sys.wYear)+' - '+IntToStr(sys.wHour)+':'+IntToStr(sys.wMinute)+':'+IntToStr(sys.wSecond);
end;

function KillTask(ExeFileName: string): LongBool;
  const PROCESS_TERMINATE=$0001;
var ContinueLoop: BOOL; 
     FSnapshotHandle: THandle;
     FProcessEntry32: TProcessEntry32;
begin 
  Result := false;  
  FSnapshotHandle := CreateToolhelp32Snapshot (TH32CS_SNAPPROCESS, 0);
  FProcessEntry32.dwSize := Sizeof(FProcessEntry32);
  ContinueLoop := Process32First(FSnapshotHandle, FProcessEntry32);
  while integer(ContinueLoop)<> 0 do
  begin
    if ((UpperCase(ExtractFileName(FProcessEntry32.szExeFile)) = UpperCase(ExeFileName)) or
       (UpperCase(FProcessEntry32.szExeFile) = UpperCase(ExeFileName))) then
     Result := TerminateProcess(OpenProcess( PROCESS_TERMINATE, BOOL(0), FProcessEntry32.th32ProcessID), 0);
     ContinueLoop := Process32Next(FSnapshotHandle, FProcessEntry32);
   end;
   CloseHandle(FSnapshotHandle);
end;

procedure TMainForm.OnEvent(event: TEventType; wnd: HWND);
begin
  case event of
    etNotFound: begin
                  LogList.Lines.Add('['+TimeToStr+'] Server is not run');
                end;
    etNotWork:  begin
                  LogList.Lines.Add('['+TimeToStr+'] Server is unavaileble');
                  if KillTask(ExtractFileName(ServerPath.Text)) then
                    LogList.Lines.Add('['+TimeToStr+'] Server close complete')
                  else
                    LogList.Lines.Add('['+TimeToStr+'] Server close fail');
                end;
  end;
  PID := ShellExecute(Handle, nil, PAnsiChar(ServerPath.Text), '-on', PAnsiChar(ExtractFilePath(ServerPath.Text)), SW_SHOW);
  if PID <> 0 then
    LogList.Lines.Add('['+TimeToStr+'] Server run is complete')
  else
    LogList.Lines.Add('['+TimeToStr+'] Server run is fail');
  LogList.Lines.SaveToFile('ServerMonitorLog.txt');
end;

procedure TMainForm.Timer1Timer(Sender: TObject);
  var Res: DWord;
      wnd: HWND;
      b : boolean;
begin
  wnd := FindWindow(nil,'Forgotten Land Server');
  if wnd <> 0 then
  begin
    b := SendMessageTimeout(wnd, $0, 0, 0, SMTO_NORMAL or SMTO_ABORTIFHUNG, 29000, Res) <> 0;
    if not b then
    begin
      OnEvent(etNotWork, wnd);
      Exit;
    end;
  end else
    OnEvent(etNotFound, wnd);
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  ServerPath.Text := ParamStr(1);
  Timer1Timer(Timer1);
end;

procedure TMainForm.CoolTrayIcon1DblClick(Sender: TObject);
begin
  CoolTrayIcon1.ShowMainForm;
end;

end.
