unit Connections;

interface

uses ScktComp;

type
 TConnectionType = (ctHTTPServer,ctGameClient);
 TConnection = class
  _type: TConnectionType;
  login: string;
  Socket: TCustomWinSocket;
  _id: integer;
  customvalue: integer;
  playerid: integer;
  constructor Create(name: string; s: TCustomWinSocket; t: TConnectionType);
  destructor Destroy;
  function Send(msg: string): integer;
 end;

function FindConnection(login: string): integer;
function FindConnectionS(Socket: TCustomWinSocket): integer;
function StrToConnType(s: string): TConnectionType;
function ConnTypeToStr(t: TConnectionType): string;

var allsocks: array of TConnection;
    sockcount: integer = 0;

const
 NewPack = #10#12;

implementation

function StrToConnType(s: string): TConnectionType;
begin
 if s = 'http' then Result:= ctHTTPServer;
 if s = 'game' then Result:= ctGameClient;
end;

function ConnTypeToStr(t: TConnectionType): string;
begin
 if t = ctHTTPServer then Result:= 'http';
 if t = ctGameClient then Result:= 'game';
end;

{ TConnection }

function TConnection.Send(msg: string): integer;
begin
 Result:= Socket.SendText(AnsiToUTF8(msg)+NewPack);
end;

constructor TConnection.Create(name: string; s: TCustomWinSocket; t: TConnectionType);
begin
 inherited Create;
 socket:= s;
 login:= name;
 _type:= t;
 _id:= sockcount;
 customvalue:= -1;
 playerid:= -1;
 inc(sockcount);
 SetLength(allsocks,sockcount);
 allsocks[_id]:= Self;
end;

destructor TConnection.Destroy;
begin
 inherited Destroy;
 dec(sockcount);
 allsocks[_id]:= allsocks[sockcount];
 allsocks[_id]._id:= _id;
 socket:= nil;
end;

function FindConnection(login: string): integer;
 var i: integer;
begin
 for i:= 0 to sockcount-1 do
  if allsocks[i].login = login then
  begin
   Result:= i;
   exit;
 end;
 Result:= -1;
end;

function FindConnectionS(Socket: TCustomWinSocket): integer;
 var i: integer;
begin
 for i:= 0 to sockcount-1 do
  if allsocks[i].Socket = Socket then
  begin
   Result:= i;
   exit;
 end;
 Result:= -1;
end;

end.
