unit mgscript;

interface

function GetComName(line: string):string;
function GetComParams(line: string):string;
function GetComParam(params: string; pos: integer):string;
function RawCodeToInt(raw: string): integer;
function IntToRawCode(int: integer): string;
function GetChildObj(comname: string; lvl: integer): string;
function GetParentObj(comname: string; lvl: integer): string;
function RemoveSpace(str: string): string;

implementation

uses Dialogs;

{FROM MATH UNIT}
function IntPower(const Base: Extended; const Exponent: Integer): Extended;
asm
        mov     ecx, eax
        cdq
        fld1                      { Result := 1 }
        xor     eax, edx
        sub     eax, edx          { eax := Abs(Exponent) }
        jz      @@3
        fld     Base
        jmp     @@2
@@1:    fmul    ST, ST            { X := Base * Base }
@@2:    shr     eax,1
        jnc     @@1
        fmul    ST(1),ST          { Result := Result * X }
        jnz     @@1
        fstp    st                { pop X from FPU stack }
        cmp     ecx, 0
        jge     @@3
        fld1
        fdivrp                    { Result := 1 / Result }
@@3:
        fwait
end;
function Power(const Base, Exponent: Extended): Extended;
begin
  if Exponent = 0.0 then
    Result := 1.0               { n**0 = 1 }
  else if (Base = 0.0) and (Exponent > 0.0) then
    Result := 0.0               { 0**n = 0, n > 0 }
  else if (Frac(Exponent) = 0.0) and (Abs(Exponent) <= MaxInt) then
    Result := IntPower(Base, Integer(Trunc(Exponent)))
  else
    Result := Exp(Exponent * Ln(Base))
end;
{END MATH UNIT}

function Translate(c,ss: integer):string;
 var i,n: integer;
     ost: array [0..255] of integer;
begin
 n:= 0;
 i:= c;
 Result:= '';
 if ss > 1 then
 begin
  while i >= ss do
  begin
   ost[n]:= i mod ss;
   i:= i div ss;
   n:= n + 1;
  end;
  ost[n]:= i;
  for i:=0 to n do
    Result:= Char(ost[i])+Result;
 end;
end;

function GetChildObj(comname: string; lvl: integer): string;
 var i,n: integer;
begin
 Result:= '';
 n:= 1;
 for i:= 1 to Length(comname) do
 begin
  if (n = lvl) and (comname[i] <> '.') then Result:= Result + comname[i];
  if comname[i] = '.' then inc(n);
  if comname[i] = '(' then exit;
  if n > lvl then exit;
 end;
end;

//Find Parent Name Obj
function GetParentObj(comname: string; lvl: integer): string;
var i,j: integer;
    pobj: string;
begin
 j:= 1;
 for i:= Length(comname) downto 1 do
 begin
  if comname[i] = '.' then inc(j);
  if (lvl = j) and (comname[i] <> '.') then pobj:= comname[i]+pobj;
 end;
 Result:= pobj;
end;

function Pow(c,s: integer): integer;
 var i: integer;
begin
 Result:= c;
 if s = 1 then exit;
 if s = 0 then
 begin
  Result:= 1;
  exit;
 end;
 for i:= 2 to s do
  Result:= Result*c;
end;

function IntToRawCode(int: integer): string;
begin
 Result:= Translate(int,256);
end;

function RawCodeToInt(raw: string): integer;
 var i,l: integer;
begin
 Result:= 0;
 l:= Length(raw);
 Result:= Byte(raw[1])*256*256*256+Byte(raw[2])*256*256+Byte(raw[3])*256+Byte(raw[4]);
 //for i:= 1 to l do
 // Result:= Result+Integer(raw[i])*Pow(256,l-1);
end;

function GetComName(line: string):string;
 var i: integer;
begin
 result:= '';
 for i:= 1 to Length(line) do
 begin
  if line[i] = '(' then exit;
  if (line[i] <> ' ') and (line[i] <> '(') then Result:= Result + line[i];
 end;
end;

function GetComParams(line: string):string;
 var i,scobcount: integer;
     get,strpar: boolean;
begin
 Result:= '';
 get:= false;
 strpar:= false;
 scobcount:= 0;
 for i:= 1 to Length(line) do
 begin
  if line[i] = '"' then strpar:= not strpar;
  if line[i] = ')' then
  begin
   if not strpar then dec(scobcount);
   if scobcount = 0 then exit;
  end;
  if get then
  begin
   if strpar then
    result:= result + line[i]
   else
    if line[i] <> ' ' then
     result:= result + line[i];
  end;
  if line[i] = '(' then
  begin
   if scobcount = 0 then get:= true;
   if not strpar then inc(scobcount);
  end;
 end;
end;

function GetComParam(params: string; pos: integer):string;
 var par: string;
     i,n: integer;
     isstr: boolean;
begin
 par:= '';
 isstr:= false;
 n:= 1;
 for i:= 1 to Length(params) do
 begin
  if not isstr then
   if params[i] = ',' then inc(n);
  if params[i] = '"' then isstr:= not isstr;
  if (n = pos) and isstr then
   if params[i] <> '"' then par:= par + params[i];
  if (n = pos) and (not isstr) then
   if (params[i] <> ' ') and (params[i] <> ',') and (params[i] <> '"') then par:= par + params[i];
 end;
 Result:= par;
end;

function RemoveSpace(str: string): string;
 var i: integer;
     isstr: boolean;
begin
 Result:= '';
 isstr:= false;
 for i:= 1 to Length(str) do
 begin
  if isstr then Result:= Result + str[i];
  if (not isstr) and (str[i] <> ' ') then Result:= Result+str[i];
  if str[i] = '"' then isstr:= not isstr;
 end;
end;



end.
