unit QuestEditor;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Spin;

type
  TQuestEditorDialog = class(TForm)
    Title: TEdit;
    OKBtn: TButton;
    CancelBtn: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Discription: TEdit;
    IconPath: TEdit;
    Label3: TLabel;
    Status: TEdit;
    Label4: TLabel;
    Label5: TLabel;
    Finish: TEdit;
    Complete: TEdit;
    Effect: TEdit;
    NeedLvl: TSpinEdit;
    ForClassBox: TGroupBox;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    Item: array [0..15] of TEdit;
    ItemLabel: array [0..15] of TLabel;
    ForClass: array [0..9] of TCheckBox;
    Need: array [0..4] of TEdit;
    NeedLabel: array [0..4] of TLabel;
    function Execute: TModalResult;
    procedure ClearData;
  end;

var
  QuestEditorDialog: TQuestEditorDialog;

implementation

{$R *.dfm}

procedure TQuestEditorDialog.ClearData;
  var i: integer;
begin
  Title.Text := '';
  Discription.Text := '';
  IconPath.Text := '';
  for i := 0 to 15 do
    Item[i].Text := '';
  for i := 0 to 4 do
    Need[i].Text := '';
end;

function TQuestEditorDialog.Execute: TModalResult;
begin
  Result := ShowModal;
end;

procedure TQuestEditorDialog.FormCreate(Sender: TObject);
 var i: integer;
begin
  for i := 0 to 9 do
  begin
    ForClass[i] := TCheckBox.Create(ForClassBox);
    ForClass[i].Parent := ForClassBox;
    ForClass[i].Checked := true;
    ForClass[i].Visible := true;//false;
    ForClass[i].Caption := '';
    ForClass[i].Left := 8;
    ForClass[i].Top := 16 + i*16;
  end;
  for i := 0 to 4 do
  begin
    Need[i] := TEdit.Create(self);
    Need[i].Parent := Self;
    Need[i].Left := 480;
    Need[i].Top := 8 + i*24;
    Need[i].Width := 153;
    NeedLabel[i] := TLabel.Create(Self);
    NeedLabel[i].Parent := Self;
    NeedLabel[i].Left := 416;
    NeedLabel[i].Top := Need[i].Top;
    NeedLabel[i].Caption := 'Need path['+IntToStr(i)+']';
  end;
  for i := 0 to 15 do
  begin
    Item[i] := TEdit.Create(Self);
    Item[i].Parent := Self;
    Item[i].Left := 64;
    Item[i].Top := ForClassBox.Top + ForClassBox.Width+8+i*24;
    Item[i].Width := 345;
    ItemLabel[i] := TLabel.Create(Self);
    ItemLabel[i].Parent := Self;
    ItemLabel[i].Left := 8;
    ItemLabel[i].Top := Item[i].Top;
    ItemLabel[i].Caption := 'Item['+IntToStr(i)+']';
  end;
  Height := Item[15].Top + Item[15].Height+30;
end;

end.
