unit Utils;

interface

  uses SysUtils;

  type
    TIntStack = class
      public
        procedure Push (int: integer);
        function Pop(var int: integer): boolean;
        function IsHave(int: integer): boolean;
      private
        list: array of integer;
        count: cardinal;
    end;

    function RealToStr(r: real): string;
    function StrToReal(chaine: string): Real;
    function StrToBool(s: string): boolean;
    function BoolToStr(b: boolean): string;
    
    function IsIntVar(s: string): boolean;
    function IsRealVar(str: string): boolean;
    function IsBoolVar(str: string): boolean;
    function FloatStrToInt(s: string): integer;

implementation

  function FloatStrToInt(s: string): integer;
    var r: real;
        pos: integer;
  begin
    Val(s, r, Pos);
    if Pos > 0 then
      Val(Copy(s, 1, Pos - 1), r, Pos);
    Result := Round(r);
  end;

  function BoolToStr(b: boolean): string;
  begin
    Result:= 'False';
    if b then Result:= 'True';
  end;

  function StrToBool(s: string): boolean;
  begin
    Result:= false;
    if LowerCase(s) = 'true' then Result:= true;
  end;

  function IsIntVar(s: string): boolean;
    var i,E: integer;
  begin
    val(s, i, E);
    Result := E = 0;
  end;

  function IsRealVar(str: string): boolean;
   var r: real;
     e: integer;
  begin
    Val(str,r,e);
    Result:= e = 0;
  end;

  function IsBoolVar(str: string): boolean;
  begin
    Result := (str = 'True') or (str = 'False');
  end;

  function StrToReal(chaine: string): Real;
    var r: Real;
        Pos: Integer;
  begin
    Val(chaine, r, Pos);
    if Pos > 0 then
      Val(Copy(chaine, 1, Pos - 1), r, Pos);
    Result:= r;
  end;

  function RealToStr(r: real): string;
  begin
    str(r:0:5, Result);
  end;

{ TIntStack }

function TIntStack.IsHave(int: integer): boolean;
  var
    i: integer;
begin
  Result := true;
  for i := 0 to count - 1 do
    if list[i] = int then Exit;
  Result := false;
end;

function TIntStack.Pop( var int: integer ): boolean;
begin
  Result := count > 0;
  if Result then
  begin
    dec(count);
    int := List[count];
  end;
end;

procedure TIntStack.Push(int: integer);
  var id: cardinal;
begin
  id := count;
  inc(count);
  SetLength(List, count);
  List[id] := int;
end;

end.
