unit players;

interface

uses ScktComp;

type
 TPlayer = class
  charid,id: integer;
  Socket: TCustomWinSocket;
  constructor Create(s: TCustomWinSocket; c: integer);
  destructor Destroy;
  public
   function GetName: string;
   procedure Kick;
 end;
 TPlayers = array of TPlayer; 

function FindPlayerBySocket(S: TCustomWinSocket): integer;

var
 allplayers: TPlayers;
 playercount: integer = 0;

implementation

uses Main;

function FindPlayerBySocket(S: TCustomWinSocket): integer;
 var i: integer;
begin
 for i:= 0 to playercount-1 do
  if allplayers[i].Socket = S then
  begin
   Result:= i;
   exit;
  end;
 Result:= -1;
end;

//==================
constructor TPlayer.Create(s: TCustomWinSocket; c: integer);
begin
 inherited Create;
 id:= playercount;
 inc(playercount);
 SetLength(allplayers,playercount);
 allplayers[id]:= Self;
 socket:= s;
 charid:= c;
end;

function TPlayer.GetName: string;
 var i: integer;
begin
 i:= DataBase.FindCharByID(charid);
 if i < 0 then exit;
 Result:= DataBase.Chars[i].name;
end;

procedure TPlayer.Kick;
begin
 Form1.AddLog('Player '+GetName+' was Kicked');
 Socket.SendText('servermsg ('+AnsiToUTF8(' ')+')'+delitel);
 Socket.Close;
end;

destructor TPlayer.Destroy;
begin
 dec(playercount);
 allplayers[id]:= allplayers[playercount];
 allplayers[id].id:= id;
 socket:= nil;
 charid:= 0;
end;

end.
